## wtdbg2 2.5

=== Makefile ===
VERSION=2.5
RELEASE=20190621

CC  := gcc
BIN := /usr/local/bin

ifeq (0, ${MAKELEVEL})
TIMESTAMP=$(shell date)
endif

ifeq (1, ${DEBUG})
CFLAGS=-g3 -W -Wall -Wno-unused-but-set-variable -O0 -DDEBUG=1 -DVERSION="$(VERSION)" -DRELEASE="$(RELEASE)" -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -mpopcnt -msse4.2
else
CFLAGS=-g3 -W -Wall -Wno-unused-but-set-variable -O4 -DVERSION="$(VERSION)" -DRELEASE="$(RELEASE)" -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -mpopcnt -msse4.2
endif

GLIBS=-lm -lrt -lpthread -lz
GENERIC_SRC=mem_share.h chararray.h sort.h list.h pgzf.h sort.h list.h dna.h thread.h filereader.h filewriter.h bitvec.h bit2vec.h bitsvec.h hashset.h

PROGS=kbm2 wtdbg2 wtdbg-cns wtpoa-cns pgzf

all: $(PROGS)

kbm2: $(GENERIC_SRC) kbm.c kbm.h kbmpoa.h wtpoa.h tripoa.h poacns.h kswx.h ksw.h ksw.c
	$(CC) $(CFLAGS) -o $@ kbm.c ksw.c $(GLIBS)

wtdbg2: $(GENERIC_SRC) wtdbg.c wtdbg-graph.h wtdbg.h kbm.h kswx.h ksw.h ksw.c kbmpoa.h wtpoa.h tripoa.h poacns.h
	$(CC) $(CFLAGS) -o $@ wtdbg.c ksw.c $(GLIBS)

wtdbg-cns: $(GENERIC_SRC) wtdbg-cns.c kswx.h ksw.h ksw.c dbgcns.h dagcns.h queue.h general_graph.h
	$(CC) $(CFLAGS) -o wtdbg-cns wtdbg-cns.c ksw.c $(GLIBS)

wtpoa-cns: $(GENERIC_SRC) wtpoa.h wtpoa-cns.c poacns.h tripoa.h ksw.h ksw.c
	$(CC) $(CFLAGS) -o $@ wtpoa-cns.c ksw.c $(GLIBS)

pgzf: mem_share.h sort.h list.h thread.h pgzf.h pgzf.c
	$(CC) $(CFLAGS) -o $@ pgzf.c $(GLIBS)

best_sam_hits4longreads: $(GENERIC_SRC) best_sam_hits4longreads.c
	$(CC) $(CFLAGS) -o $@ best_sam_hits4longreads.c $(GLIBS)

clean:
	rm -f *.o *.gcda *.gcno *.gcov gmon.out $(PROGS)

clear:
	rm -f *.o *.gcda *.gcno *.gcov gmon.out

install: $(PROGS)
	mkdir -p $(BIN) && cp -fvu $(PROGS) $(BIN)

=== debian/changelog ===
wtdbg2 (2.5-11) unstable; urgency=medium

  * d/patches/*: normalize Last-Update timestamp.
  * gcc-15.patch: fix build failure with gcc-15. (Closes: #1098113)
  * d/watch: convert to v5 Github template.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/control: declare compliance to standards version 4.7.2.

 -- Étienne Mollier <emollier@debian.org>  Mon, 20 Oct 2025 22:17:19 +0200

wtdbg2 (2.5-10) unstable; urgency=medium

  * d/rules: repair double source builds.
    This involved cleaning up traces of CPU flag specific builds, in the
    context of SIMDe builds.  This also involved preserving a number of
    files affected by sed commands doing a wealth of changes on a number
    of files.  Lists of binaries and CPU flags involved in the cleanup
    process could be reused to simplify a bit the build procedure.
    (Closes: #1045984)
  * d/control: declare compliance to standards version 4.7.0.
  * d/control: add myself to uploaders.

 -- Étienne Mollier <emollier@debian.org>  Sat, 04 May 2024 19:59:44 +0200

wtdbg2 (2.5-9) unstable; urgency=medium

  * Set  Architecture: amd64  since this seems to be the only architecture
    without autopkgtest issues
    Closes: #1025249
  * Fix download name of upstream tarball
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 01 Dec 2022 17:13:05 +0100

wtdbg2 (2.5-8) unstable; urgency=medium

  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 01 Sep 2021 17:15:39 +0200

wtdbg2 (2.5-7) unstable; urgency=medium

  * Team Upload.
  * move wtdbg2-examples to "Suggests"
  * s/MIT/Expat (fix with cme)
  * Include run-unit-test script in examples binary

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 03 Sep 2020 15:24:21 +0530

wtdbg2 (2.5-6) unstable; urgency=medium

  * Make sure simd-dispatch will be installed only in main package
    Closes: #968275

 -- Andreas Tille <tille@debian.org>  Thu, 13 Aug 2020 15:16:51 +0200

wtdbg2 (2.5-5) unstable; urgency=medium

  * Team upload.
  * Source only upload for testing migration

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 11 Aug 2020 18:40:50 +0530

wtdbg2 (2.5-4) unstable; urgency=medium

  * Team Upload.
  * Add autopkgtests
  * Save up space by not extracting the binary
  * New binary: wtdbg2-examples
  * Minor fixes on manpages
  * Fix spellings

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 09 Aug 2020 20:28:18 +0530

wtdbg2 (2.5-3) unstable; urgency=medium

  * Team upload.
  * Build on all architectures and don't violate the i386/amd64 baselines
    Closes: #958091
  * Install the scripts to /usr/share/wtdbg2/ and add their dependencies under
    "Suggests"
  * Install the README.md

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 19 Apr 2020 10:56:49 +0200

wtdbg2 (2.5-2) unstable; urgency=medium

  * Source only upload

 -- Andreas Tille <tille@debian.org>  Mon, 06 Apr 2020 11:53:09 +0200

wtdbg2 (2.5-1) unstable; urgency=medium

  * Initial release (Closes: #955548)

 -- Andreas Tille <tille@debian.org>  Thu, 02 Apr 2020 13:39:43 +0200

=== debian/control ===
Source: wtdbg2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               zlib1g-dev,
               libsimde-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/wtdbg2
Vcs-Git: https://salsa.debian.org/med-team/wtdbg2.git
Homepage: https://github.com/ruanjue/wtdbg2

Package: wtdbg2
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: ${perl:Depends},
          minimap2,
          samtools,
          mummer,
          wtdbg2-examples
Description: de novo sequence assembler for long noisy reads
 Wtdbg2 is a de novo sequence assembler for long noisy reads produced by
 PacBio or Oxford Nanopore Technologies (ONT). It assembles raw reads
 without error correction and then builds the consensus from intermediate
 assembly output. Wtdbg2 is able to assemble the human and even the 32Gb
 Axolotl genome at a speed tens of times faster than CANU and FALCON
 while producing contigs of comparable base accuracy.
 .
 During assembly, wtdbg2 chops reads into 1024bp segments, merges similar
 segments into a vertex and connects vertices based on the segment
 adjacency on reads. The resulting graph is called fuzzy Bruijn graph
 (FBG). It is akin to De Bruijn graph but permits mismatches/gaps and
 keeps read paths when collapsing k-mers. The use of FBG distinguishes
 wtdbg2 from the majority of long-read assemblers.

Package: wtdbg2-examples
Architecture: all
Depends: ${misc:Depends}
Enhances: wtdbg2
Multi-Arch: foreign
Description: Examples for wtdbg - de novo sequence assembler
 Wtdbg2 is a de novo sequence assembler for long noisy reads produced by
 PacBio or Oxford Nanopore Technologies (ONT). It assembles raw reads
 without error correction and then builds the consensus from intermediate
 assembly output. Wtdbg2 is able to assemble the human and even the 32Gb
 Axolotl genome at a speed tens of times faster than CANU and FALCON
 while producing contigs of comparable base accuracy.
 .
 This package contains a test data set as well as sample scripts
 running some test suite provided by Debian also as autopkgtest.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=-DSIMDE_ENABLE_OPENMP -fopenmp-simd
export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

prefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr
libexecdir=$(prefix)/lib/$(DEB_SOURCE)
BINARIES=kbm2 wtdbg2 wtdbg-cns wtpoa-cns pgzf
AMD64_FLAGS=avx2 avx sse4.1 ssse3 sse3 sse2
I386_FLAGS=sse2 sse mmx

%:
	dh $@

override_dh_auto_build:
	sed -i.dh_clean \
		-e '1s/\/usr\/bin\/env perl/\/usr\/bin\/perl/' \
		-e 's/memeory/memory/' \
		-e 's/automaticly/automatically/' \
		-e 's/ouput/output/' \
		-e 's/vaule/value/' \
		-e 's/annonymous/anonymous/' \
		scripts/* *.c *.h *.md
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p $(prefix)
	mkdir -p $(libexecdir)
	for SIMD in $(AMD64_FLAGS); do \
		export CFLAGS="$(CFLAGS) -m$${SIMD}" ; \
		make clean ; \
		dh_auto_build -- SFX=-$${SIMD} ; \
	done
else ifeq (i386,$(DEB_HOST_ARCH))
	mkdir -p $(prefix)
	mkdir -p $(libexecdir)
	for SIMD in $(I386_FLAGS); do \
		export CFLAGS="$(CXXFLAGS) -m$${SIMD}" ; \
		make clean ; \
		dh_auto_build -- SFX=-$${SIMD} ; \
	done
	dh_auto_build -- SFX=-plain
else
	dh_auto_build
endif

override_dh_auto_install:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install -p $(DEB_SOURCE) debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	for SIMD in $(AMD64_FLAGS); do \
		export CFLAGS="$(CFLAGS) -m$${SIMD}" ; \
		dh_auto_build -- SFX=-$${SIMD} BIN=$(libexecdir) install ; \
	done
	mkdir -p $(prefix)/bin
	cd $(prefix)/bin \
		&& for prog in $(BINARIES); do \
		ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else ifeq (i386,$(DEB_HOST_ARCH))
	dh_install -p $(DEB_SOURCE) debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	for SIMD in $(I386_FLAGS); do \
		export CFLAGS="$(CFLAGS) -m$${SIMD}" ; \
		dh_auto_build -- SFX=-$${SIMD} BIN=$(libexecdir) install ; \
	done
	export CLFAGS="$(CFLAGS)" ; dh_auto_build -- SFX=-plain BIN=$(libexecdir) \
		install
	mkdir -p $(prefix)/bin
	cd $(prefix)/bin \
		&& for prog in $(BINARIES); do \
		ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else
	make BIN=debian/$(DEB_SOURCE)/usr/bin install
endif

execute_after_dh_auto_clean:
ifeq (amd64,$(DEB_HOST_ARCH))
	$(RM) $(foreach binary,$(BINARIES), \
		$(foreach flag,$(AMD64_FLAGS), \
			$(binary)-$(flag) \
		) \
	) # Cleanup additional binaries built for amd64 sub architectures.
else ifeq (i386,$(DEB_HOST_ARCH))
	$(RM) $(foreach binary,$(BINARIES), \
		$(foreach flag,$(I386_FLAGS), \
			$(binary)-$(flag) \
		) \
	) # Cleanup additional binaries built for i386 sub architectures.
endif
	: $(foreach f,$(wildcard *.dh_clean scripts/*.dh_clean), \
		&& mv -v $(f) $(f:.dh_clean=) \
	) # Cleanup the wealth of files modified by sed for various typos.

# Avoid introduction of backup files from the sed stream in binary packages.
execute_after_dh_install:
	find debian/ -name '*.dh_clean' -delete

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, bwa, minimap2, samtools
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Template: Github
Owner: ruanjue
Project: wtdbg2
